'dA Info script 0.3 Text File Parser
'hammad.s@gmail.com for queries/help. Would be glad to assist.

'General set of variables
'Name of Text File where info is stored
TMP_FILE = "dA00x.tmp"
SITE_URL = "http://www.deviantart.com/"
PAGE_CHECK = "<title>deviantART:"

UN_FC = "Deviant"
UN_FC2 = ".deviantart.com/"">"
UN_EC = "</a>"

TT_FC = "<li>is a"
TT_FC2 = "<strong>"
TT_EC = "</strong></li>"

TM_FC = "<a href=""http://my.deviantart.com/devwatch/"">"
TM_FC2 = "		"
TM_EC = " message centre</a> item"

DW_FC = "deviantWatch"
DW_FC2 = """>"
DW_EC = "D</a>"

HT_FC = "hot topic"
HT_FC2 = """>"
HT_EC = "H</span>"

MM_FC = "miscellaneous message"
MM_FC2 = """>"
MM_EC = "M</span>"

C_FC = "comment"
C_FC2 = "you wrote"">"
C_EC = "C</span>"

J_FC = "journal"
J_FC2 = """>"
J_EC = "J</span>"

JP_FC = "journal poll"
JP_FC2 = """>"
JP_EC = "P</span>"

N_FC = "note"
N_FC2 = ">"
N_EC = "N</a>"

'Function to parse all values into the text file
Function GetDeviantInfoFile()
	HTML_STR = ReturnHTML(SITE_URL)
	UN = GetInfo(HTML_STR, UN_FC, UN_FC2, UN_EC)
	UN_URL = "http://" & UN & ".deviantart.com/"
	UN_HTML = ReturnHTML(UN_URL)
	Title = GetInfo(UN_HTML, TT_FC, TT_FC2, TT_EC)
	TMs = BOS((GetInfo(HTML_STR, TM_FC, TM_FC2, TM_EC)), "message", "")
	xDs =  GetInfo(HTML_STR, DW_FC, DW_FC2, DW_EC)
	xHTs = GetInfo(HTML_STR, HT_FC, HT_FC2, HT_EC)
	xMMs = GetInfo(HTML_STR, MM_FC, MM_FC2, MM_EC)
	xCs =  GetInfo(HTML_STR, C_FC, C_FC2, C_EC)
	xJs =  GetInfo(HTML_STR, J_FC, J_FC2, J_EC)
	xJPs = GetInfo(HTML_STR, JP_FC, JP_FC2, JP_EC)
	xNs =  GetInfo(HTML_STR, N_FC, N_FC2, N_EC)
	yDs =  BOS(xDs, "deviation", "")
	yHTs = BOS(xHTs, "hot topic", "")
	yMMs = BOS(xMMs, "misc. message", "")
	yCs =  BOS(xCs, "comment", "")
	yJs =  BOS(xJs, "journal entry", "journal entries")
	yJPs = BOS(xJPs, "journal poll", "")
	yNs =  BOS(xNs, "note", "notes")
	Ds =  Zero(xDs)
	HTs = Zero(xHTs)
	MMs = Zero(xMMs)
	Cs =  Zero(xCs)
	Js =  Zero(xJs)
	JPs = Zero(xJPs)
	Ns =  Zero(xNs)
	if Ds <> "" then
		Ds = Ds & "D "
	end if
	if HTs <> "" then
		HTs = HTs & "H "
	end if
	if MMs <> "" then
		MMs = MMs & "M "
	end if
	if Cs <> "" then
		Cs = Cs & "C "
	end if
	if Js <> "" then
		Js = Js & "J "
	end if
	if JPs <> "" then
		JPs = JPs & "P "
	end if
	if Ns <> "" then
		Ns = Ns & "N "
	end if
	All = trim(Ds & HTs & MMs & Cs & Js & JPs & Ns)
	dA_i = UN & vbCrLf & Title & vbCrLf & TMs & vbCrLf & yDs & vbCrLf & yHTs & vbCrLf & yMMs & vbCrLf & yCs & vbCrLf & yJs & vbCrLf & yJPs & vbCrLf & yNs & vbCrLf & All
	set fs=CreateObject("Scripting.FileSystemObject")
	set f=fs.CreateTextFile(TMP_FILE,true)
	f.write(dA_i)
	f.close
	set f=nothing
	set fs=nothing
	GetDeviantInfoFile = "OK!"
End Function

Private Function Zero(IN_STR)
	outx = NULL
	if IN_STR = "0" then
		outx = ""
	else
		outx = IN_STR
	end if
	Zero = outx
End Function

'Build Output String
Private Function BOS(IN_N, SINGULAR_N, PLURAL_N)
	IN_N = trim(IN_N)
	if PLURAL_N = "" then
		PLURAL_N = SINGULAR_N & "s"
	end if
	if IN_N = "0" then
		OUT_N = "No " & PLURAL_N
	else
		if IN_N = "1" then
			OUT_N = "One " & SINGULAR_N
		else
			OUT_N = IN_N & " " & PLURAL_N
		end if
	end if
	BOS = OUT_N
End Function

'Based on NeM's script template:
Private Function GetInfo(HTML_STRx, FIRST_CHECK, FIRST_CHECK2, END_CHECK)
	dim htmlResult,output,newsItem,mainFeature
	htmlResult = HTML_STRx
	output = NULL
	startPos = instr(htmlResult, PAGE_CHECK)
	if startPos > 0 then
		if instr(startPos, htmlResult, FIRST_CHECK)>0 then
			posOne = instr( startPos, htmlResult, FIRST_CHECK)
			posOne = instr( posOne, htmlResult, FIRST_CHECK2) + Len(FIRST_CHECK2)	
			posTwo = instr( posOne, htmlResult, END_CHECK)
			if posOne > 0 AND posTwo > posOne Then
				'grab the name of the news item
				newsItem = right(mid( htmlResult, posOne, posTwo-posOne ), posTwo-posOne)
			end if
			output = trim(newsItem)
		else
			output = "0"
		end if
	else
		output = "0"
	end if
	GetInfo = output
End Function

Private Function ReturnHTML(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	HTML = objXMLHTTP.responseBody
	Set objRS = CreateObject("ADODB.Recordset")
	objRS.Fields.Append "txt", 200, 45000, &H00000080
	objRS.Open
	objRS.AddNew
	objRS.Fields("txt").AppendChunk HTML
	ReturnHTML = objRS("txt").Value
	objRS.Close
	Set objRS = Nothing
	Set objXMLHTTP = Nothing
End Function

Private Function TrimHTML(str)
	pos_deb = InStr(1, str, "<")
	Do Until pos_deb = 0
	    pos_fin = InStr(pos_deb, str, ">")
	    part_d = Mid(str, 1, pos_deb - 1)
	    part_f = Mid(str, pos_fin + 1, Len(str) - pos_fin)
	    str = part_d & part_f
	    pos_deb = InStr(1, str, "<")
	Loop
	TrimHTML = str
End Function